unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, Grids,
  DBGrids;

type

  { TMyDBGrid }

  TMyDBGrid = class(TDBGrid)
  protected
    procedure DrawCell(aCol, aRow: Integer; aRect: TRect;
      aState: TGridDrawState); override;
  end;

  { TForm1 }

  TForm1 = class(TForm)
    DBGrid1: TDBGrid;
    procedure FormCreate(Sender: TObject);
    procedure DBGrid1ColumnMoved(Sender: TObject; FromIndex,
      ToIndex: Integer);
  private
    procedure InitNewGrid;
  public
    NewDBGrid: TMyDBGrid;
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.InitNewGrid;
var
  i: Integer;
begin
  NewDBGrid := TMyDBGrid.Create(Self);

  {Copied from the lfm and adapted to NewDBGrid;
  -----------------------------------------------}
  NewDBGrid.Left := 0;
  NewDBGrid.Height := 192;
  NewDBGrid.Top := 48;
  NewDBGrid.Width := 320;
  NewDBGrid.Align := alBottom;
  NewDBGrid.Color := clMoneyGreen;
  NewDBGrid.OnColumnMoved := @DBGrid1ColumnMoved;
  {Add columns; not really needed if dgeAutoColumns in OptionsExtra}
  for i := 1 to 3 do
    NewDBGrid.Columns.Add;
  {----------------------------------------------}

  { Now we can set the parent to show the grid }
  NewDBGrid.Parent := Self;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  DBGrid1.Free; {< it was needed only during design-time }
  InitNewGrid;
end;

procedure TForm1.DBGrid1ColumnMoved(Sender: TObject; FromIndex,
  ToIndex: Integer);
begin
  {Do nothing; it's just to show we can set event handlers}
end;

{ TMyDBGrid }

procedure TMyDBGrid.DrawCell(aCol, aRow: Integer; aRect: TRect;
  aState: TGridDrawState);
begin
  //ShowMessage('I am an interceptor !!!');
  inherited DrawCell(aCol, aRow, aRect, aState);
end;

end.

